this.inlets = 1;
this.outlets = 2;

mgraphics.init();
mgraphics.relative_coords = 0;
mgraphics.autofill = 0;

var myFont = "Arial";
var mySize = 15.0;
var myMessage = "If you have any questions you can feel free to ask in \
the Javascript forum area or email me directly at ddg@cycling74.com. \
Questions about Max? Drop me a line - it is what I do...";
var margin = 20;
var cornerRadius = 20;

// variables for the actual word wrapped drawing
var textHeight = 0;
var wrapText = new Array();

mgraphics.redraw();

function loadbang()
{
	//sendFontList();
}

function paint()
{
	var sw = box.rect[2] - box.rect[0];
	var textLocation;	
	
	doWordWrap();
	
	with (mgraphics) {
		set_source_rgba(0, 0, 0, 0.6667);
	//	move_to(0,0);
		rectangle_rounded(0, 0, sw, textHeight * wrapText.length+1.5*margin, cornerRadius, cornerRadius);
		fill();
		
		set_source_rgba(1, 1, 1, 1);
		select_font_face(myFont);
		set_font_size(mySize);
		
		// post(wrapText.length, textHeight, '\n');
		
		for (var i=0; i<wrapText.length; i++) {
			textLocation = textHeight * (i + 1);
			move_to(margin, textLocation+0.5*margin);
			text_path(wrapText[i]);
			fill();
		}

	}
}

function setFont(v)
{
	myFont = v;
	mgraphics.redraw();
}

function setSize(v)
{
	mySize = myClip(v, 0.5, 200.0);
	mgraphics.redraw();
}

function setMessage(v)
{
	myMessage = v;
	mgraphics.redraw();
}

function sendFontList()
{
	var fl = mgraphics.getfontlist();
	outlet(1, "clear");
	
	for (var i=0; i<fl.length; i++) {
		outlet(1, "append", fl[i]);
	}
}

function myClip(v, mn, mx)
{
	return Math.min(mx, Math.max(mn, v));
}
myClip.local = 1;

// Here is a quick and dirty word wrapping function...
// improved by Arvid Tomayko 2014-06
function doWordWrap()
{
	var sw = box.rect[2] - box.rect[0];	
	var tmpText = null;
	var tmpString = null;
	
	wrapText = new Array();

	with (mgraphics) {
		select_font_face(myFont);
		set_font_size(mySize);
		
		var tm = text_measure(myMessage);
		textHeight = tm[1];	// set the text height.
		
		if (tm[0] <= sw) {
			// good enough to print
			wrapText.push(myMessage);
		} else {
			// have to wrap
			tmpText = myMessage.split(" ");
			tmpString = "";
			var st = 0;
			var en = -1;
			var i = 0; //change: init i
			
			while (i < tmpText.length) { //changed to a while loop
				tmpString += tmpText[i] + " ";
				tm = text_measure(tmpString);
				
				if (tm[0] > (sw - margin*2)) { //using a margin variable instead of hard coding it
					if (en == -1) {
						// a really big word - just print it
						wrapText.push(tmpString);
						st = ++i; //change: pre-increment i. was st = i+1;
						en = -1;
						tmpString = "";
					} else {
						tmpString = "";
						for (var j=st; j<=en; j++) {
							tmpString += tmpText[j] + " ";
						}
						wrapText.push(tmpString);
						tmpString = ""; //changed to clear string
						//was tmpString = tmpText[i] + " ";
						st = i;
						en = -1;
					}
				} else {
					en = i++; //change: increment i here
				}
			}
			// pick up the last line
			wrapText.push(tmpString);
		}
	}
	
	gc();	// leave a clean campsite...
}		
doWordWrap.local = 1;

function setMargin(a) {
	margin = a;
	mgraphics.redraw();
}

function setCornerRadius(a) {
	cornerRadius = a;
	mgraphics.redraw();
}
